Prompt:
What pipeline patterns exist in Apache Beam?

Response:
Beam pipeline patterns are a set of best practices for building Apache Beam pipelines. They are based on real-world Beam deployments and are designed to help you build resilient, flexible, and portable pipelines.

The following list includes some of the most common pipeline patterns:
- [File processing patterns](https://beam.apache.org/documentation/patterns/file-processing/)
- [Pipeline options patterns](https://beam.apache.org/documentation/patterns/pipeline-options/)
- [Side input patterns](https://beam.apache.org/documentation/patterns/side-inputs/)
- [Windowing patterns](https://beam.apache.org/documentation/patterns/custom-windows/)
- [State and Timers patterns](https://beam.apache.org/documentation/patterns/grouping-elements-for-efficient-external-service-calls/)

For more information, see the [Pipeline Patterns](https://beam.apache.org/documentation/patterns/overview/) section of the Beam Programming Guide.
