/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.beam.sdk.extensions.euphoria.core.client.operator.hint;

import org.apache.beam.sdk.extensions.euphoria.core.annotation.audience.Audience;

/**
 * Extra information for runner about Dataset size.
 *
 * @deprecated Hints unsupported for now
 */
@Audience(Audience.Type.CLIENT)
@Deprecated
public enum SizeHint implements OutputHint {
  /**
   * Indicate to runner that dataset can fit in memory and this information could be used for
   * optimization (e.g. Broadcast hash join).
   */
  FITS_IN_MEMORY
}
